Index: palm/trunk/SOURCE/turbulence_closure_mod.f90
===================================================================
--- palm/trunk/SOURCE/turbulence_closure_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/turbulence_closure_mod.f90	(revision 4671)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of downward facing USM and LSM surfaces
+!
+! 4625 2020-07-24 12:13:16Z oliver.maas
 ! for turbulence_closure = '1.5-order-dai': copy value of distance_to_wall to
 ! ghostpoints at dirichlet/radiation boundaries
@@ -268,5 +271,6 @@
                surf_lsm_v,                                                                         &
                surf_usm_h,                                                                         &
-               surf_usm_v
+               surf_usm_v,                                                                         &
+               surf_type
 
     IMPLICIT NONE
@@ -475,17 +479,17 @@
 !
 !--       Natural surfaces
-          DO  m = 1, surf_lsm_h%ns
-             i = surf_lsm_h%i(m)
-             j = surf_lsm_h%j(m)
-             k = surf_lsm_h%k(m)
-             e_p(k,j,i) = ( surf_lsm_h%us(m) / c_0 )**2
+          DO  m = 1, surf_lsm_h(0)%ns
+             i = surf_lsm_h(0)%i(m)
+             j = surf_lsm_h(0)%j(m)
+             k = surf_lsm_h(0)%k(m)
+             e_p(k,j,i) = ( surf_lsm_h(0)%us(m) / c_0 )**2
           ENDDO
 !
 !--       Urban surfaces
-          DO  m = 1, surf_usm_h%ns
-             i = surf_usm_h%i(m)
-             j = surf_usm_h%j(m)
-             k = surf_usm_h%k(m)
-             e_p(k,j,i) = ( surf_usm_h%us(m) / c_0 )**2
+          DO  m = 1, surf_usm_h(0)%ns
+             i = surf_usm_h(0)%i(m)
+             j = surf_usm_h(0)%j(m)
+             k = surf_usm_h(0)%k(m)
+             e_p(k,j,i) = ( surf_usm_h(0)%us(m) / c_0 )**2
           ENDDO
 !
@@ -579,17 +583,17 @@
 !
 !--    Natural surfaces
-       DO  m = 1, surf_lsm_h%ns
-          i = surf_lsm_h%i(m)
-          j = surf_lsm_h%j(m)
-          k = surf_lsm_h%k(m)
-          diss_p(k,j,i) = surf_lsm_h%us(m)**3 / ( kappa * surf_lsm_h%z_mo(m) )
+       DO  m = 1, surf_lsm_h(0)%ns
+          i = surf_lsm_h(0)%i(m)
+          j = surf_lsm_h(0)%j(m)
+          k = surf_lsm_h(0)%k(m)
+          diss_p(k,j,i) = surf_lsm_h(0)%us(m)**3 / ( kappa * surf_lsm_h(0)%z_mo(m) )
        ENDDO
 !
 !--    Urban surfaces
-       DO  m = 1, surf_usm_h%ns
-          i = surf_usm_h%i(m)
-          j = surf_usm_h%j(m)
-          k = surf_usm_h%k(m)
-          diss_p(k,j,i) = surf_usm_h%us(m)**3 / ( kappa * surf_usm_h%z_mo(m) )
+       DO  m = 1, surf_usm_h(0)%ns
+          i = surf_usm_h(0)%i(m)
+          j = surf_usm_h(0)%j(m)
+          k = surf_usm_h(0)%k(m)
+          diss_p(k,j,i) = surf_usm_h(0)%us(m)**3 / ( kappa * surf_usm_h(0)%z_mo(m) )
        ENDDO
 !
@@ -2150,30 +2154,56 @@
        ENDDO
 !
-!--    Natural surfaces, upward-facing
+!--    Natural surfaces, upward- and downward facing
        !$OMP PARALLEL DO PRIVATE(i,j,k,m)
        !$ACC PARALLEL LOOP PRIVATE(i, j, k, m, km_sfc) &
-       !$ACC PRESENT(surf_lsm_h, u, v, drho_air_zw, zu)
-       DO  m = 1, surf_lsm_h%ns
-
-          i = surf_lsm_h%i(m)
-          j = surf_lsm_h%j(m)
-          k = surf_lsm_h%k(m)
+       !$ACC PRESENT(surf_lsm_h(0), u, v, drho_air_zw, zu)
+       DO  m = 1, surf_lsm_h(0)%ns
+
+          i = surf_lsm_h(0)%i(m)
+          j = surf_lsm_h(0)%j(m)
+          k = surf_lsm_h(0)%k(m)
 !
 !--       Note, calculation of u_0 and v_0 is not fully accurate, as u/v and km are not on the same
 !--       grid. Actually, a further interpolation of km onto the u/v-grid is necessary. However, the
 !--       effect of this error is negligible.
-          km_sfc = kappa * surf_lsm_h%us(m) * surf_lsm_h%z_mo(m) /                                 &
-                   phi_m( surf_lsm_h%z_mo(m) / surf_lsm_h%ol(m) )
-
-          surf_lsm_h%u_0(m) = u(k+1,j,i) + surf_lsm_h%usws(m) * drho_air_zw(k-1) *                 &
+          km_sfc = kappa * surf_lsm_h(0)%us(m) * surf_lsm_h(0)%z_mo(m) /                                 &
+                   phi_m( surf_lsm_h(0)%z_mo(m) / surf_lsm_h(0)%ol(m) )
+
+          surf_lsm_h(0)%u_0(m) = u(k+1,j,i) + surf_lsm_h(0)%usws(m) * drho_air_zw(k-1) *                 &
                               ( zu(k+1) - zu(k-1) ) / ( km_sfc  + 1.0E-20_wp )
-          surf_lsm_h%v_0(m) = v(k+1,j,i) + surf_lsm_h%vsws(m) * drho_air_zw(k-1) *                 &
+          surf_lsm_h(0)%v_0(m) = v(k+1,j,i) + surf_lsm_h(0)%vsws(m) * drho_air_zw(k-1) *                 &
                                         ( zu(k+1) - zu(k-1)) / ( km_sfc  + 1.0E-20_wp )
 
-          IF ( ABS( u(k+1,j,i) - surf_lsm_h%u_0(m) ) > ABS( u(k+1,j,i) - u(k-1,j,i) ) )            &
-             surf_lsm_h%u_0(m) = u(k-1,j,i)
-
-          IF ( ABS( v(k+1,j,i) - surf_lsm_h%v_0(m) ) > ABS( v(k+1,j,i) - v(k-1,j,i) ) )            &
-             surf_lsm_h%v_0(m) = v(k-1,j,i)
+          IF ( ABS( u(k+1,j,i) - surf_lsm_h(0)%u_0(m) ) > ABS( u(k+1,j,i) - u(k-1,j,i) ) )            &
+             surf_lsm_h(0)%u_0(m) = u(k-1,j,i)
+
+          IF ( ABS( v(k+1,j,i) - surf_lsm_h(0)%v_0(m) ) > ABS( v(k+1,j,i) - v(k-1,j,i) ) )            &
+             surf_lsm_h(0)%v_0(m) = v(k-1,j,i)
+
+       ENDDO
+!
+!--    Natural surfaces, downward-facing surfaces
+       !$OMP PARALLEL DO PRIVATE(i,j,k,m)
+       !$ACC PARALLEL LOOP PRIVATE(i, j, k, m, km_sfc) &
+       !$ACC PRESENT(surf_lsm_h(1), u, v, drho_air_zw, zu, km)
+       DO  m = 1, surf_lsm_h(1)%ns
+
+          i = surf_lsm_h(1)%i(m)
+          j = surf_lsm_h(1)%j(m)
+          k = surf_lsm_h(1)%k(m)
+!
+!--       Note, calculation of u_0 and v_0 is not fully accurate, as u/v and km are not on the same
+!--       grid. Actually, a further interpolation of km onto the u/v-grid is necessary. However, the
+!--       effect of this error is negligible.
+          surf_lsm_h(1)%u_0(m) = u(k-1,j,i) - surf_lsm_h(1)%usws(m) * drho_air_zw(k-1) *           &
+                                     ( zu(k+1) - zu(k-1) ) / ( km(k,j,i) + 1.0E-20_wp )
+          surf_lsm_h(1)%v_0(m) = v(k-1,j,i) - surf_lsm_h(1)%vsws(m) * drho_air_zw(k-1) *           &
+                                     ( zu(k+1) - zu(k-1) ) / (km(k,j,i) + 1.0E-20_wp )
+
+          IF ( ABS( surf_lsm_h(1)%u_0(m) - u(k-1,j,i) ) > ABS( u(k+1,j,i) - u(k-1,j,i) ) )         &
+             surf_lsm_h(1)%u_0(m) = u(k+1,j,i)
+
+          IF ( ABS( surf_lsm_h(1)%v_0(m) - v(k-1,j,i) ) > ABS( v(k+1,j,i) - v(k-1,j,i) ) )         &
+             surf_lsm_h(1)%v_0(m) = v(k+1,j,i)
 
        ENDDO
@@ -2182,27 +2212,53 @@
        !$OMP PARALLEL DO PRIVATE(i,j,k,m)
        !$ACC PARALLEL LOOP PRIVATE(i, j, k, m, km_sfc) &
-       !$ACC PRESENT(surf_usm_h, u, v, drho_air_zw, zu)
-       DO  m = 1, surf_usm_h%ns
-
-          i = surf_usm_h%i(m)
-          j = surf_usm_h%j(m)
-          k = surf_usm_h%k(m)
+       !$ACC PRESENT(surf_usm_h(0), u, v, drho_air_zw, zu)
+       DO  m = 1, surf_usm_h(0)%ns
+
+          i = surf_usm_h(0)%i(m)
+          j = surf_usm_h(0)%j(m)
+          k = surf_usm_h(0)%k(m)
 !
 !--       Note, calculation of u_0 and v_0 is not fully accurate, as u/v and km are not on the same
 !--       grid. Actually, a further interpolation of km onto the u/v-grid is necessary. However, the
 !--       effect of this error is negligible.
-          km_sfc = kappa * surf_usm_h%us(m) * surf_usm_h%z_mo(m) /                                 &
-                   phi_m( surf_usm_h%z_mo(m) / surf_usm_h%ol(m) )
-
-          surf_usm_h%u_0(m) = u(k+1,j,i) + surf_usm_h%usws(m) * drho_air_zw(k-1) *                 &
+          km_sfc = kappa * surf_usm_h(0)%us(m) * surf_usm_h(0)%z_mo(m) /                                 &
+                   phi_m( surf_usm_h(0)%z_mo(m) / surf_usm_h(0)%ol(m) )
+
+          surf_usm_h(0)%u_0(m) = u(k+1,j,i) + surf_usm_h(0)%usws(m) * drho_air_zw(k-1) *                 &
                                         ( zu(k+1) - zu(k-1) ) / ( km_sfc  + 1.0E-20_wp )
-          surf_usm_h%v_0(m) = v(k+1,j,i) + surf_usm_h%vsws(m) * drho_air_zw(k-1) *                 &
+          surf_usm_h(0)%v_0(m) = v(k+1,j,i) + surf_usm_h(0)%vsws(m) * drho_air_zw(k-1) *                 &
                                         ( zu(k+1) - zu(k-1) ) / ( km_sfc  + 1.0E-20_wp )
 
-          IF ( ABS( u(k+1,j,i) - surf_usm_h%u_0(m) ) > ABS( u(k+1,j,i) - u(k-1,j,i) ) )            &
-             surf_usm_h%u_0(m) = u(k-1,j,i)
-
-          IF ( ABS( v(k+1,j,i) - surf_usm_h%v_0(m) ) > ABS( v(k+1,j,i) - v(k-1,j,i) ) )            &
-             surf_usm_h%v_0(m) = v(k-1,j,i)
+          IF ( ABS( u(k+1,j,i) - surf_usm_h(0)%u_0(m) ) > ABS( u(k+1,j,i) - u(k-1,j,i) ) )            &
+             surf_usm_h(0)%u_0(m) = u(k-1,j,i)
+
+          IF ( ABS( v(k+1,j,i) - surf_usm_h(0)%v_0(m) ) > ABS( v(k+1,j,i) - v(k-1,j,i) ) )            &
+             surf_usm_h(0)%v_0(m) = v(k-1,j,i)
+
+       ENDDO
+!
+!--    Urban surfaces, downward-facing surfaces
+       !$OMP PARALLEL DO PRIVATE(i,j,k,m)
+       !$ACC PARALLEL LOOP PRIVATE(i, j, k, m, km_sfc) &
+       !$ACC PRESENT(surf_usm_h(1), u, v, drho_air_zw, zu, km)
+       DO  m = 1, surf_usm_h(1)%ns
+
+          i = surf_usm_h(1)%i(m)
+          j = surf_usm_h(1)%j(m)
+          k = surf_usm_h(1)%k(m)
+!
+!--       Note, calculation of u_0 and v_0 is not fully accurate, as u/v and km are not on the same
+!--       grid. Actually, a further interpolation of km onto the u/v-grid is necessary. However, the
+!--       effect of this error is negligible.
+          surf_usm_h(1)%u_0(m) = u(k-1,j,i) - surf_usm_h(1)%usws(m) * drho_air_zw(k-1) *           &
+                                     ( zu(k+1) - zu(k-1) ) / ( km(k,j,i) + 1.0E-20_wp )
+          surf_usm_h(1)%v_0(m) = v(k-1,j,i) - surf_usm_h(1)%vsws(m) * drho_air_zw(k-1) *           &
+                                     ( zu(k+1) - zu(k-1) ) / (km(k,j,i) + 1.0E-20_wp )
+
+          IF ( ABS( surf_usm_h(1)%u_0(m) - u(k-1,j,i) ) > ABS( u(k+1,j,i) - u(k-1,j,i) ) )         &
+             surf_usm_h(1)%u_0(m) = u(k+1,j,i)
+
+          IF ( ABS( surf_usm_h(1)%v_0(m) - v(k-1,j,i) ) > ABS( v(k+1,j,i) - v(k-1,j,i) ) )         &
+             surf_usm_h(1)%v_0(m) = v(k+1,j,i)
 
        ENDDO
@@ -2963,28 +3019,28 @@
 !
 !--          Natural surfaces
-             surf_s = surf_lsm_h%start_index(j,i)
-             surf_e = surf_lsm_h%end_index(j,i)
+             surf_s = surf_lsm_h(0)%start_index(j,i)
+             surf_e = surf_lsm_h(0)%end_index(j,i)
              !$ACC LOOP PRIVATE(m, k)
              DO  m = surf_s, surf_e
-                k = surf_lsm_h%k(m)
-
-                dudz(k) = ( u(k+1,j,i) - surf_lsm_h%u_0(m) ) * dd2zu(k)
-                dvdz(k) = ( v(k+1,j,i) - surf_lsm_h%v_0(m) ) * dd2zu(k)
+                k = surf_lsm_h(0)%k(m)
+
+                dudz(k) = ( u(k+1,j,i) - surf_lsm_h(0)%u_0(m) ) * dd2zu(k)
+                dvdz(k) = ( v(k+1,j,i) - surf_lsm_h(0)%v_0(m) ) * dd2zu(k)
 
              ENDDO
 !
 !--          Urban surfaces
-             surf_s = surf_usm_h%start_index(j,i)
-             surf_e = surf_usm_h%end_index(j,i)
+             surf_s = surf_usm_h(0)%start_index(j,i)
+             surf_e = surf_usm_h(0)%end_index(j,i)
              !$ACC LOOP PRIVATE(m, k)
              DO  m = surf_s, surf_e
-                k = surf_usm_h%k(m)
-
-                dudz(k) = ( u(k+1,j,i) - surf_usm_h%u_0(m) ) * dd2zu(k)
-                dvdz(k) = ( v(k+1,j,i) - surf_usm_h%v_0(m) ) * dd2zu(k)
-
-             ENDDO
-!
-!--          Compute gradients at downward-facing walls, only for non-natural default surfaces
+                k = surf_usm_h(0)%k(m)
+
+                dudz(k) = ( u(k+1,j,i) - surf_usm_h(0)%u_0(m) ) * dd2zu(k)
+                dvdz(k) = ( v(k+1,j,i) - surf_usm_h(0)%v_0(m) ) * dd2zu(k)
+
+             ENDDO
+!
+!--          Compute gradients at downward-facing surfaces, default surfaces
              surf_s = surf_def_h(1)%start_index(j,i)
              surf_e = surf_def_h(1)%end_index(j,i)
@@ -2995,4 +3051,28 @@
                 dudz(k) = ( surf_def_h(1)%u_0(m) - u(k-1,j,i) ) * dd2zu(k)
                 dvdz(k) = ( surf_def_h(1)%v_0(m) - v(k-1,j,i) ) * dd2zu(k)
+
+             ENDDO
+!
+!--          Compute gradients at downward-facing surfaces, natural surfaces
+             surf_s = surf_lsm_h(1)%start_index(j,i)
+             surf_e = surf_lsm_h(1)%end_index(j,i)
+             !$ACC LOOP PRIVATE(m, k)
+             DO  m = surf_s, surf_e
+                k = surf_lsm_h(1)%k(m)
+
+                dudz(k) = ( surf_lsm_h(1)%u_0(m) - u(k-1,j,i) ) * dd2zu(k)
+                dvdz(k) = ( surf_lsm_h(1)%v_0(m) - v(k-1,j,i) ) * dd2zu(k)
+
+             ENDDO
+!
+!--          Compute gradients at downward-facing surfaces, urban surfaces
+             surf_s = surf_usm_h(1)%start_index(j,i)
+             surf_e = surf_usm_h(1)%end_index(j,i)
+             !$ACC LOOP PRIVATE(m, k)
+             DO  m = surf_s, surf_e
+                k = surf_usm_h(1)%k(m)
+
+                dudz(k) = ( surf_usm_h(1)%u_0(m) - u(k-1,j,i) ) * dd2zu(k)
+                dvdz(k) = ( surf_usm_h(1)%v_0(m) - v(k-1,j,i) ) * dd2zu(k)
 
              ENDDO
@@ -3125,22 +3205,22 @@
                             tmp_flux(k) = drho_air_zw(k-1) * surf_def_h(l)%shf(m)
                          ENDDO
-                      ENDDO
-!
-!--                   Natural surfaces
-                      surf_s = surf_lsm_h%start_index(j,i)
-                      surf_e = surf_lsm_h%end_index(j,i)
-                      !$ACC LOOP PRIVATE(m, k)
-                      DO  m = surf_s, surf_e
-                         k = surf_lsm_h%k(m)
-                         tmp_flux(k) = drho_air_zw(k-1) * surf_lsm_h%shf(m)
-                      ENDDO
-!
-!--                   Urban surfaces
-                      surf_s = surf_usm_h%start_index(j,i)
-                      surf_e = surf_usm_h%end_index(j,i)
-                      !$ACC LOOP PRIVATE(m, k)
-                      DO  m = surf_s, surf_e
-                         k = surf_usm_h%k(m)
-                         tmp_flux(k) = drho_air_zw(k-1) * surf_usm_h%shf(m)
+!
+!--                      Natural surfaces
+                         surf_s = surf_lsm_h(l)%start_index(j,i)
+                         surf_e = surf_lsm_h(l)%end_index(j,i)
+                         !$ACC LOOP PRIVATE(m, k)
+                         DO  m = surf_s, surf_e
+                            k = surf_lsm_h(l)%k(m)
+                            tmp_flux(k) = drho_air_zw(k-1) * surf_lsm_h(l)%shf(m)
+                         ENDDO
+!
+!--                      Urban surfaces
+                         surf_s = surf_usm_h(l)%start_index(j,i)
+                         surf_e = surf_usm_h(l)%end_index(j,i)
+                         !$ACC LOOP PRIVATE(m, k)
+                         DO  m = surf_s, surf_e
+                            k = surf_usm_h(l)%k(m)
+                            tmp_flux(k) = drho_air_zw(k-1) * surf_usm_h(l)%shf(m)
+                         ENDDO
                       ENDDO
                    ENDIF
@@ -3261,63 +3341,67 @@
 !
 !--                Treat horizontal natural surfaces
-                   surf_s = surf_lsm_h%start_index(j,i)
-                   surf_e = surf_lsm_h%end_index(j,i)
-                   DO  m = surf_s, surf_e
-                      k = surf_lsm_h%k(m)
-
-                      IF (  .NOT.  bulk_cloud_model  .AND.  .NOT.  cloud_droplets )  THEN
-                         k1 = 1.0_wp + 0.61_wp * q(k,j,i)
-                         k2 = 0.61_wp * pt(k,j,i)
-                      ELSE IF ( bulk_cloud_model )  THEN
-                         IF ( ql(k,j,i) == 0.0_wp )  THEN
+                   DO  l = 0, 1
+                      surf_s = surf_lsm_h(l)%start_index(j,i)
+                      surf_e = surf_lsm_h(l)%end_index(j,i)
+                      DO  m = surf_s, surf_e
+                         k = surf_lsm_h(l)%k(m)
+
+                         IF (  .NOT.  bulk_cloud_model  .AND.  .NOT.  cloud_droplets )  THEN
                             k1 = 1.0_wp + 0.61_wp * q(k,j,i)
                             k2 = 0.61_wp * pt(k,j,i)
-                         ELSE
-                            theta = pt(k,j,i) + d_exner(k) * lv_d_cp * ql(k,j,i)
-                            temp  = theta * exner(k)
-                            k1 = ( 1.0_wp - q(k,j,i) + 1.61_wp * ( q(k,j,i) - ql(k,j,i) ) *        &
-                                 ( 1.0_wp + rd_d_rv * lv_d_rd / temp ) ) /                         &
-                                 ( 1.0_wp + rd_d_rv * lv_d_rd * lv_d_cp *                          &
-                                 ( q(k,j,i) - ql(k,j,i) ) / ( temp * temp ) )
-                            k2 = theta * ( lv_d_cp / temp * k1 - 1.0_wp )
+                         ELSE IF ( bulk_cloud_model )  THEN
+                            IF ( ql(k,j,i) == 0.0_wp )  THEN
+                               k1 = 1.0_wp + 0.61_wp * q(k,j,i)
+                               k2 = 0.61_wp * pt(k,j,i)
+                            ELSE
+                               theta = pt(k,j,i) + d_exner(k) * lv_d_cp * ql(k,j,i)
+                               temp  = theta * exner(k)
+                               k1 = ( 1.0_wp - q(k,j,i) + 1.61_wp * ( q(k,j,i) - ql(k,j,i) ) *        &
+                                    ( 1.0_wp + rd_d_rv * lv_d_rd / temp ) ) /                         &
+                                    ( 1.0_wp + rd_d_rv * lv_d_rd * lv_d_cp *                          &
+                                    ( q(k,j,i) - ql(k,j,i) ) / ( temp * temp ) )
+                               k2 = theta * ( lv_d_cp / temp * k1 - 1.0_wp )
+                            ENDIF
+                         ELSE IF ( cloud_droplets )  THEN
+                            k1 = 1.0_wp + 0.61_wp * q(k,j,i) - ql(k,j,i)
+                            k2 = 0.61_wp * pt(k,j,i)
                          ENDIF
-                      ELSE IF ( cloud_droplets )  THEN
-                         k1 = 1.0_wp + 0.61_wp * q(k,j,i) - ql(k,j,i)
-                         k2 = 0.61_wp * pt(k,j,i)
-                      ENDIF
-
-                      tmp_flux(k) = ( k1 * surf_lsm_h%shf(m) + k2 * surf_lsm_h%qsws(m) )           &
-                                    * drho_air_zw(k-1)
+
+                         tmp_flux(k) = ( k1 * surf_lsm_h(l)%shf(m) + k2 * surf_lsm_h(l)%qsws(m) )     &
+                                       * drho_air_zw(k-1)
+                      ENDDO
                    ENDDO
 !
 !--                Treat horizontal urban surfaces
-                   surf_s = surf_usm_h%start_index(j,i)
-                   surf_e = surf_usm_h%end_index(j,i)
-                   DO  m = surf_s, surf_e
-                      k = surf_usm_h%k(m)
-
-                      IF ( .NOT. bulk_cloud_model  .AND.  .NOT. cloud_droplets )  THEN
-                         k1 = 1.0_wp + 0.61_wp * q(k,j,i)
-                         k2 = 0.61_wp * pt(k,j,i)
-                      ELSE IF ( bulk_cloud_model )  THEN
-                         IF ( ql(k,j,i) == 0.0_wp )  THEN
+                   DO  l = 0, 1
+                      surf_s = surf_usm_h(l)%start_index(j,i)
+                      surf_e = surf_usm_h(l)%end_index(j,i)
+                      DO  m = surf_s, surf_e
+                         k = surf_usm_h(l)%k(m)
+
+                         IF ( .NOT. bulk_cloud_model  .AND.  .NOT. cloud_droplets )  THEN
                             k1 = 1.0_wp + 0.61_wp * q(k,j,i)
                             k2 = 0.61_wp * pt(k,j,i)
-                         ELSE
-                            theta = pt(k,j,i) + d_exner(k) * lv_d_cp * ql(k,j,i)
-                            temp  = theta * exner(k)
-                            k1 = ( 1.0_wp - q(k,j,i) + 1.61_wp * ( q(k,j,i) - ql(k,j,i) ) *        &
-                                 ( 1.0_wp + rd_d_rv * lv_d_rd / temp ) ) /                         &
-                                 ( 1.0_wp + rd_d_rv * lv_d_rd * lv_d_cp *                          &
-                                 ( q(k,j,i) - ql(k,j,i) ) / ( temp * temp ) )
-                            k2 = theta * ( lv_d_cp / temp * k1 - 1.0_wp )
+                         ELSE IF ( bulk_cloud_model )  THEN
+                            IF ( ql(k,j,i) == 0.0_wp )  THEN
+                               k1 = 1.0_wp + 0.61_wp * q(k,j,i)
+                               k2 = 0.61_wp * pt(k,j,i)
+                            ELSE
+                               theta = pt(k,j,i) + d_exner(k) * lv_d_cp * ql(k,j,i)
+                               temp  = theta * exner(k)
+                               k1 = ( 1.0_wp - q(k,j,i) + 1.61_wp * ( q(k,j,i) - ql(k,j,i) ) *        &
+                                    ( 1.0_wp + rd_d_rv * lv_d_rd / temp ) ) /                         &
+                                    ( 1.0_wp + rd_d_rv * lv_d_rd * lv_d_cp *                          &
+                                    ( q(k,j,i) - ql(k,j,i) ) / ( temp * temp ) )
+                               k2 = theta * ( lv_d_cp / temp * k1 - 1.0_wp )
+                            ENDIF
+                         ELSE IF ( cloud_droplets )  THEN
+                            k1 = 1.0_wp + 0.61_wp * q(k,j,i) - ql(k,j,i)
+                            k2 = 0.61_wp * pt(k,j,i)
                          ENDIF
-                      ELSE IF ( cloud_droplets )  THEN
-                         k1 = 1.0_wp + 0.61_wp * q(k,j,i) - ql(k,j,i)
-                         k2 = 0.61_wp * pt(k,j,i)
-                      ENDIF
-
-                      tmp_flux(k) = ( k1 * surf_usm_h%shf(m) + k2 * surf_usm_h%qsws(m) )           &
-                                    * drho_air_zw(k-1)
+
+                         tmp_flux(k) = ( k1 * surf_usm_h(l)%shf(m) + k2 * surf_usm_h(l)%qsws(m) )     &
+                                       * drho_air_zw(k-1)
+                      ENDDO
                    ENDDO
 
@@ -3613,34 +3697,50 @@
 !
 !--    Natural surfaces
-       surf_s = surf_lsm_h%start_index(j,i)
-       surf_e = surf_lsm_h%end_index(j,i)
+       surf_s = surf_lsm_h(0)%start_index(j,i)
+       surf_e = surf_lsm_h(0)%end_index(j,i)
        DO  m = surf_s, surf_e
-          k = surf_lsm_h%k(m)
-
-          dudz(k) = ( u(k+1,j,i) - surf_lsm_h%u_0(m) ) * dd2zu(k)
-          dvdz(k) = ( v(k+1,j,i) - surf_lsm_h%v_0(m) ) * dd2zu(k)
+          k = surf_lsm_h(0)%k(m)
+
+          dudz(k) = ( u(k+1,j,i) - surf_lsm_h(0)%u_0(m) ) * dd2zu(k)
+          dvdz(k) = ( v(k+1,j,i) - surf_lsm_h(0)%v_0(m) ) * dd2zu(k)
 
        ENDDO
 !
 !--    Urban surfaces
-       surf_s = surf_usm_h%start_index(j,i)
-       surf_e = surf_usm_h%end_index(j,i)
+       surf_s = surf_usm_h(0)%start_index(j,i)
+       surf_e = surf_usm_h(0)%end_index(j,i)
        DO  m = surf_s, surf_e
-          k = surf_usm_h%k(m)
-
-          dudz(k) = ( u(k+1,j,i) - surf_usm_h%u_0(m) ) * dd2zu(k)
-          dvdz(k) = ( v(k+1,j,i) - surf_usm_h%v_0(m) ) * dd2zu(k)
+          k = surf_usm_h(0)%k(m)
+
+          dudz(k) = ( u(k+1,j,i) - surf_usm_h(0)%u_0(m) ) * dd2zu(k)
+          dvdz(k) = ( v(k+1,j,i) - surf_usm_h(0)%v_0(m) ) * dd2zu(k)
 
        ENDDO
 !
-!--    Compute gradients at downward-facing walls, only for non-natural default surfaces
+!--    Compute gradients at downward-facing surfaces, default surfaces
        surf_s = surf_def_h(1)%start_index(j,i)
        surf_e = surf_def_h(1)%end_index(j,i)
        DO  m = surf_s, surf_e
           k = surf_def_h(1)%k(m)
-
           dudz(k) = ( surf_def_h(1)%u_0(m) - u(k-1,j,i) ) * dd2zu(k)
           dvdz(k) = ( surf_def_h(1)%v_0(m) - v(k-1,j,i) ) * dd2zu(k)
-
+       ENDDO
+!
+!--    Compute gradients at downward-facing surfaces, natural surfaces
+       surf_s = surf_lsm_h(1)%start_index(j,i)
+       surf_e = surf_lsm_h(1)%end_index(j,i)
+       DO  m = surf_s, surf_e
+          k = surf_lsm_h(1)%k(m)
+          dudz(k) = ( surf_lsm_h(1)%u_0(m) - u(k-1,j,i) ) * dd2zu(k)
+          dvdz(k) = ( surf_lsm_h(1)%v_0(m) - v(k-1,j,i) ) * dd2zu(k)
+       ENDDO
+!
+!--    Compute gradients at downward-facing surfaces, urban surfaces
+       surf_s = surf_usm_h(1)%start_index(j,i)
+       surf_e = surf_usm_h(1)%end_index(j,i)
+       DO  m = surf_s, surf_e
+          k = surf_usm_h(1)%k(m)
+          dudz(k) = ( surf_usm_h(1)%u_0(m) - u(k-1,j,i) ) * dd2zu(k)
+          dvdz(k) = ( surf_usm_h(1)%v_0(m) - v(k-1,j,i) ) * dd2zu(k)
        ENDDO
 
@@ -3747,20 +3847,20 @@
                       tmp_flux(k) = drho_air_zw(k-1) * surf_def_h(l)%shf(m)
                    ENDDO
-                ENDDO
-!
-!--             Natural surfaces
-                surf_s = surf_lsm_h%start_index(j,i)
-                surf_e = surf_lsm_h%end_index(j,i)
-                DO  m = surf_s, surf_e
-                   k = surf_lsm_h%k(m)
-                   tmp_flux(k) = drho_air_zw(k-1) * surf_lsm_h%shf(m)
-                ENDDO
-!
-!--             Urban surfaces
-                surf_s = surf_usm_h%start_index(j,i)
-                surf_e = surf_usm_h%end_index(j,i)
-                DO  m = surf_s, surf_e
-                   k = surf_usm_h%k(m)
-                   tmp_flux(k) = drho_air_zw(k-1) * surf_usm_h%shf(m)
+!
+!--                Natural surfaces
+                   surf_s = surf_lsm_h(l)%start_index(j,i)
+                   surf_e = surf_lsm_h(l)%end_index(j,i)
+                   DO  m = surf_s, surf_e
+                      k = surf_lsm_h(l)%k(m)
+                      tmp_flux(k) = drho_air_zw(k-1) * surf_lsm_h(l)%shf(m)
+                   ENDDO
+!
+!--                Urban surfaces
+                   surf_s = surf_usm_h(l)%start_index(j,i)
+                   surf_e = surf_usm_h(l)%end_index(j,i)
+                   DO  m = surf_s, surf_e
+                      k = surf_usm_h(l)%k(m)
+                      tmp_flux(k) = drho_air_zw(k-1) * surf_usm_h(l)%shf(m)
+                   ENDDO
                 ENDDO
              ENDIF
@@ -3836,6 +3936,7 @@
           IF ( use_surface_fluxes )  THEN
 !
-!--          Treat horizontal default surfaces
+!--          Treat horizontal surfaces
              DO  l = 0, 1
+!--             Default surfaces
                 surf_s = surf_def_h(l)%start_index(j,i)
                 surf_e = surf_def_h(l)%end_index(j,i)
